Subject: Re: [PATCH] KVM: PPC: Book3S: Add support for H_IPOLL and H_XIRR_X in XICS emulation

From: Scott Wood <[email-masked]>
Date: Wed, 29 May 2013 19:07:13 -0500

On 05/29/2013 06:57:32 PM, Benjamin Herrenschmidt wrote:
> On Wed, 2013-05-29 at 18:38 -0500, Scott Wood wrote:
>=20
> > > Yes. I'd like to have them in. Their implementation is actually =20
> fairly
> > > trivial and they cannot be emulated by qemu if the rest of the =20
> XICS is
> > > in the kernel, so it's a problem.
> >
> > OK.  Does it make more sense for you to take it as Paul suggested, =20
> or
> > for Gleb or Marcelo to pick it up directly?
>=20
> I'll take it.

Acked-by: Scott Wood <[email-masked]>

> > Then rm_action should always be 0 for these hcalls, right?  So =20
> there's
> > no correctness reason to keep the hcalls in separate switch
> > statements.  You shave off a few cycles checking rm_action, at the =20
> cost
> > of needing to change kvmppc_xics_hcall() if a real-mode version of
> > these hcalls is ever done.
>=20
> No, because rm_action will also be 0 if the hcall was fully done in =20
> real
> mode (which can happen, that's our fast path), in which case we do =20
> *NOT*
> want to to be re-done in virtual mode.
>=20
> That's why we always return whether rm_action is 0 or not when =20
> real-mode
> is enabled.

Oh, I misread the code and thought the decision to return was based on =20
the return value of kvmppc_xics_rm_complete.  Sorry about that. :-(

-Scott=